
;*******************************************************************************
;					FM_M8_N5110_enc.asm
;	 FM-   RDA5807M  LCD- Nokia5110
;  ATMEGA8    .  8 .
; 		  :
;-*-      .
;-*-          .
;-*-         
;	         .
;-*-            
;           (3 ).
;-*-       A, C, V.
;-*-         User_set.asm
;-*-        .
;-*-       .
;-*-      .
;-*-       EEPROM.
;-*-         
;      . 
;-*-       .
;-*-  "-"   ,   .
;-*-             16 .
;
;  :
; PB0 - 
; PB1 - D/C     (1)   (0) LCD
; PB2 -     (0) LCD
; PB3 - DIN   LCD
; PB4 - RES   LCD (0)
; PB5 - CLK   LCD
;
; PC0 - 
; PC1 - 
; PC2 - .   -
; PC3 - 
; PC4 - (SDA) -   
; PC5 - (SCL) -   
;
; PD0 -   
; PD1 -   
; PD2 -  
; PD3 - 
; PD4 - 
; PD5 - 
; PD6 -     
; PD7 -     
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
	
  	;   
  	.def cntrl	= R13    	;  
  		.equ ENC = 0			;  
  		.equ SEK = 1			;  
  	;	.equ AUS = 2			;  
	.def temp  = r16 			;
	.def temp1 = r17 			; 
	.def temp2 = r18 			; 
	.def temp3 = r19 			;  
;	.def flags = r20 			; 
	.def time  = r21			;  
	.def F_3H  = r22			;.   
	.def F_3L  = r23			;.   
	.def freq  = r24			;   ( )
	.equ Tm_l  = 2				;    2*8=16 .
	
	.def R_mode = R8			;  
	    .equ vol	 = 0		; . . 
	    .equ chnl	 = 1		; . .  
		.equ au_sek  = 2		;  
	
;===============================================================================
	.DSEG					;   SRAM ()
	.ORG 0x060				;   
	decnum: 	.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
;=============================================================================
	.ESEG					;   EEPROM
	 Fst_EE:	.BYTE 1 	;   ( )
	 Vol_EE:	.BYTE 1 	; 
	 Channal:	.BYTE 60 	;  
;=============================================================================
;----------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
	
	.MACRO LOAD_ADDR 		 		;   16- 
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
		
	.MACRO 	POZ_LCD					;    LCD:
		ldi temp,@0					;    ,
		rcall lcd_X					;
		ldi temp,@1					;   
		rcall lcd_Y					;
	.ENDMACRO						;: POZ_LCD 12,5
	
;=============================================================================
	.CSEG				;  
	.ORG 0 				; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	rjmp OVF_T2			; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	rjmp OVF_T1			; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:	;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B,  .  LCD-
	 	ldi temp,0b11111111			;
		out DDRB,temp   			;      
		ldi temp,0b00000110			;   RES  SE 
		out PORTB,temp   			;
			;  
	 	ldi temp,0b00000100			;   
		out DDRC,temp   			;
		ldi temp,0b11111011			;
		out PORTC,temp   			;  
			;  D
	 	ldi temp,0b11000000			;   D
		out DDRD,temp				;
		ldi temp,0b01111111			;
		out PORTD,temp				;  D
		
			; 
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					; .  0 1  2
		ldi temp,(1<<TOIE2)|(1<<TOIE1)|(1<<TOIE0)	; 
		out TIMSK,temp				;
		ldi temp,0b00000101			; 
		out TCCR0,temp				;  0   1/1024
		out TCCR1B,temp				;  1   1/1024
		
		sei                         ;  
		
;===================   ==================================
		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		cbi PORTD,6		 			;  
		sbi PORTD,7					;  
		ldi temp,0b00000111			;  2   1/1024
		out TCCR2,temp				;
		; LCD 
		rcall lcd_init				; LCD 
		rcall lcd_clr				; LCD
		;    
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg1*2		;.  Z  
		rcall Str_LCD				; .  LCD
		
		POZ_LCD 0,4					;0- , 4- 
		LOAD_ADDR Z,Messg11*2		;.  Z  
		rcall Str_LCD				;  LCD 
		;  RDA5807
		rcall IIC_init				;  I2C
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,3					; 
		sts volume,temp				;   = 3
		rcall Rd_St					;     EEPROM
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rcall type_vol				;    LCD
		DELAY 20					; 656 
		;      
		rcall Prnt_F				;   
		rcall rekog					;/  
		;    
		rcall ch_st					; RDA5807
		DELAY 20					; 656 
		; 
		clr R2						;  
		clr R8						;  
		clr R11						;    .
		clr cntrl					;  
		clr freq					;  
		clr temp3					;  R19
		;    
		POZ_LCD 5,0					;5- , 0- 
		ldi temp,Seek_Mode			;  
		tst temp					;
		breq pereb					;
		
		clr temp					;  
		sbr temp,(1<<au_sek)		;   
		mov R8,temp					;
		;    
		POZ_LCD 5,0					;5- , 0- 
		ldi temp,'A'				;
		rcall lcd_put_char			;  A
		rjmp main					;
		
pereb:	ldi temp,'C'				;
		rcall lcd_put_char			;  C
;-------------------- ----------------------------------------------
main:
		sbrc cntrl,ENC				;  , -
		rjmp mn_upr					;    ,
		sbrc cntrl,SEK				;   , -
		rcall ch_seek				;   
		clr cntrl					;   
			; 
mn_upr:	in temp,PIND				;  
		andi temp,0b00000111		; 
		cpi temp,7					;   , -
		breq main					;   
		;
		sbrs temp,2					;   , -
		rjmp mn_sm					;    
		;   
		mov  temp1,temp				;
		andi temp1,0b00000011		;  
		cpi temp1,1					;   1, 
		breq mn_1					;   R10=1
		cpi temp1,2					;   2, 
		breq mn_2					;   R10=2
		tst temp1					;   
		breq mn_3					;  
		rjmp main					;
		
mn_1:	ldi temp1,1					;
		mov R10,temp1				; R10=1
		rjmp main					;
mn_2:	ldi temp1,2					;
		mov R10,temp1				; R10=2
		rjmp main					;
mn_3:	mov r1,R10					;   
		rjmp mn_5					;
		
		;   
mn_sm:	DELAY 1						; 32  
		sbic PIND,PD2				;    
		rjmp mn_4					;
		ldi temp,4					; 
		mov R1,temp					;  R1=4 
		inc R11						;    
		rjmp main					;
		
mn_4:	rcall mode_s				;  
		rcall light					;  
		rjmp main					;
		;   ()
mn_5:	DELAY 1						; 32  
		cp R1,R2					;  , 
		brne main					;  -  
		tst R2						;   ,-
		breq main					;  
		
		rcall light					;  
		
		;  
		sbrc R8,vol					;
		rjmp reg_vol				;    
		sbrc R8,au_sek				;
		rjmp avto					;   
		
		;  
		sbrc R10,0					;  , -
		rcall Num_Up				;     
		sbrc R10,1					;  , -
		rcall Num_Down				;     
		rjmp m_loop					; , -  
		
reg_vol:	; 
		sbrc R10,0					;  , -
		rcall vol_up				;  
		sbrc R10,1					;  , -
		rcall vol_dw				;  
		rjmp m_loop					; , -  
		
		;
avto:	sbrc R10,0					;  , -
		rcall freq_Up				;    
		sbrc R10,1					;  , -
		rcall freq_Down				;    
		
m_loop: clr R10						;  
		clr R2						;  
		rjmp main					;   
		
;===========================================================================
		;  
light:	ldi temp,Tm_l				; 
		mov R12,temp				;  
		cbi PORTD,6		 			;  
		sbi PORTD,7					;  
		ldi temp,0b00000101			;
		out TCCR1B,temp				;  1   1/1024
		ret
;===========================================================================
mode_s:		;  
		DELAY 5						;
		POZ_LCD 5,0					;5- , 0- 
		mov temp,R11				;  
		cpi temp,40					;   -
		brmi mode_1					;    V/C
		
		;    
		sbrc R8,2					;   
		rjmp mode_A					;    
			;  
		mov temp,R8					;   
		sbr temp,(1<<au_sek)		;   
		cbr temp,(1<<vol)			;   . 
		mov R8,temp					;
			;    
		ldi temp,'A'				;
		rcall lcd_put_char			;  A
		rjmp rev_end				;
			;   (  )
mode_A:	mov temp,R8					;  
		cbr temp,(1<<au_sek)|(1<<vol)		;   A  V
		mov R8,temp					;
			;    
		ldi temp,'C'				;
		rcall lcd_put_char			;  C
		rjmp rev_end				;
		
		;      
mode_1:	sbrc R8,0					;   . ., -
		rjmp mode_2					;    
			;   
		mov temp,R8					;  
		sbr temp,(1<<vol)			;   . 
		mov R8,temp					;
			;    V
		ldi temp,'V'				;
		rcall lcd_put_char			;  V
		rjmp rev_end				;
			;   
mode_2:	mov temp,R8					;  
		cbr temp,(1<<vol)			;   . 
		mov R8,temp					;
			;    /
		sbrc R8,2					;   
		rjmp ind_A					;    
		
		ldi temp,'C'				;
		rcall lcd_put_char			;  C
		rjmp rev_end				;
ind_A:	ldi temp,'A'				;
		rcall lcd_put_char			;  A
		
rev_end:
		clr R11						;    .
		clr temp					; temp    
 		ret
		
;===========================================================================
 Num_Up:			;   
 		clr R1						;
 		inc R9						;  
		mov temp,R9					;
 		cpi temp,Nst				;    > Nst
 		brmi PC+2					;
 		clr  R9						;    0
		rcall type_ch				;    LCD 
		DELAY 7						;
		
		ldi temp,255				;  
		mov R14,temp				;
		ldi temp,0b00000100			;  2   1/64
		out TCCR2,temp				;
		clr temp					;
		sbr temp,(1<<ENC)+(0<<SEK)	;   
		mov cntrl,temp				;
		
 		clr temp					;
 		
 		ret
 		
 ;===========================================================================
 Num_Down:			;   
 		clr R1						;  
		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl um_nom					;   ,  -
 		ldi temp,Nst-1				;
 		mov R9,temp					;
 um_nom:
 		rcall type_ch				;    LCD 
 		DELAY 7						;
 		
 		ldi temp,255				;   
		mov R14,temp				;
		ldi temp,0b00000100			;  2   1/64
		out TCCR2,temp				;
		clr temp					;
		sbr temp,(1<<ENC)+(0<<SEK)	;   
		mov cntrl,temp				;
 		
		clr temp					;
 		
 		ret
 		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_ch:	;    LCD
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg3*2		;.  Z   
		rcall Str_LCD				;   
		POZ_LCD 0,5					;0- , 5- 
		
			;    10- 
		clr temp1					;
		mov temp,R9					;  
		inc temp					;   1
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .   
		tst temp					;    0,  -
		brne PC+2					;    
		rjmp PC+3					;
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;   LCD
		ld temp,-Y					; .   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .     LCD
		
		ret
		
;===========================================================================
freq_Up: 	;   "+"   
		cli							; 
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				;   
		rcall Mono					; ""
		;		rjmp st_tn		// 
			;     
		ldi temp,0b10010011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
		sei							; 
 		ret
;===========================================================================
freq_Down:	;   "-"   
		cli							; 
		dec freq					; 
					;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				;   
		rcall Mono					; ""
		;			rjmp st_tn		// 
			;     
		ldi temp,0b10010001			;(02H) ., DMUTE=0,,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; 210+870=1080
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		rcall type_vol				;    LCD
		rcall rekog					; 
		rcall Prnt_F				;   
		
		clr temp					; temp    
		sei							; 
 		ret
;===========================================================================
;	/     
;---------------------------------------------------------------------------

 ch_seek:		;     . 
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
 		tst R9						;
 		breq st_set					;  =0,   
 		push R9						;
		adiw Z,16					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Prnt_F				;   
		rcall rekog					; 
		;   
ch_st:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		rcall Mono					; ""
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		rcall type_vol				;    LCD
		
		clr temp					; temp    
		sei							; 
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:	cli							; 
		clr R9						;
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  ,
		cpi temp,Nst				;    , -
		brsh fall					;     
		adiw Z,16					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Messg2*2		;  . ". "
		rjmp Prn_Ch					;  
		
na_ind:	adiw Z,1					;    
			;    
Prn_Ch:	POZ_LCD 0,5					;0- , 5- 
		rcall Str_LCD				;    
		sei							; 
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli						; 
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei						; 
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	
		cli							; 
		LOAD_ADDR Y,Fst_EE			;.  Y . .. 
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		inc YL						;
Rd_EEV:	sbic EECR,EEWE				;   
		rjmp Rd_EEV					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in temp,EEDR				;   . 
		andi temp,0x0F				;  
		sts volume,temp				;    
		sei							; 
		
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		cli							; 
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		tst temp					;  ,  -
		brpl PC+2					;
		ldi temp,0					;    
		ori temp,0b10000000			;
		rcall IIC_Send				;  
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		rcall Wr_EEV				;   
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei							; 
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	
		cli							; 
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei							; 
		
		ret
		
;===========================================================================
;		    ,  YH:YL   
;-------------------------------------------------------------------------
Wr_EEV:	cli
		ldi YL,LOW(Vol_EE)			;.  Y . ..
		clr YH						; .   
		lds temp,volume				;    
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,temp				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		ret
; ========================================================================
		; 
vol_up:	cli
		clr R1				;
		lds temp,volume		;    
		cpi temp,15			;  
		breq vol_st			; ,  
		; 
		tst temp			;
		brpl PC+3			;   , 
		clr temp			;   ,
		rjmp PC+2			;   
		inc temp			;
		sts volume,temp		;  
vol_st:	rcall wr_vol		;   RDA5807m
		DELAY 5				; 160 
		clr temp			; temp    
		sei
		ret
;========================================================================
		; 
vol_dw:	cli
		clr R1				;
		lds temp,volume		;    
		tst temp			;  .  < 0, 
		brmi PC+2			;   ,  -
		dec temp			;   
		sts volume,temp		;   
		tst temp			;   
		brpl vol_mi			;  .  < 0, 
		rcall mute			;    
		rcall type_vol		;   
		rjmp PC+2			;
		
vol_mi:	rcall wr_vol		;   RDA5807m
		DELAY 5				; 160 
		clr temp			; temp    
		sei
		ret
		
;========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
mute:	cli
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
		
		ldi temp,0b10010010			;(02H): ., DMUTE=0,,,
		rcall IIC_Send				;SEEKUP=1, SEEK=0 ( )
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		sei
		
		ret

; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
wr_vol:	;     RDA5807
		cli
		; 
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
			
		ldi temp,0b11010010			;(02H): ., DMUTE=1,,,
		rcall IIC_Send				;SEEKUP=1, SEEK=0 ( )
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		;    
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x05				;  (05H)  
		rcall IIC_Send				;
		
		ldi temp,0b10001000  		;(05H) - .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;   RDA5807m
		
		rcall iic_stop 				;  ""
		rcall type_vol				;   
		sei
		
		ret
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_vol:	;    LCD
		cli
		POZ_LCD 9,0					;8- , 0- 
		
		lds temp,volume				;    
		tst temp					;  ,  -
		brpl PC+3					;
		clr temp					;      00,
		rjmp prbr					; , -  
		inc temp					;  1 
		
  prbr:		;   10- 
		clr R17						;
		andi temp,0x1F				;  
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .  
		tst temp					;   0, 
		breq PC+3					;   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		ld temp,-Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		
		ldi temp,' '				;
		rcall lcd_put_char			; 
		
		sei
		ret
		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		cli
		;    LCD
		POZ_LCD 0,0					;0- , 0- 
		lds temp,level				;     
		
		cpi temp,51					; 4- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg10*2		;.  Z . . " 4"
		rjmp tp_lev					;    /
		
		cpi temp,38					; 3- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg9*2		;.  Z . . " 3"
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg8*2		;.  Z . . " 2"
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg7*2		;.  Z . . " 1"
		rjmp tp_lev					;    /
		
		LOAD_ADDR Z,Messg6*2		;.  Z . . " 0"
		
tp_lev:	rcall Str_LCD				;   
		sei
		ret


;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
		tst R1				;     
		breq T0_ex			;   /,  -
		mov R2,R1			;    
		
T0_ex:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
; /     1
;---------------------------------------------------------------------------
OVF_T1:	
		push R19          	;   R19
    	in R19,SREG      	;
   		push R19         	;   SREG
		;
		dec R12				; 
		tst R12				;    , -
		brne T1_ex			;   /,  -
		sbi PORTD,6			;  
		cbi PORTD,7			;  
		
		ldi R19,0			;  2
		out TCCR1B,R19		;
		;
T1_ex:	pop R19          	;   SREG
    	out SREG,R19     	;
    	pop R19          	;   R19
		
		reti
		
;===========================================================================
; /     2
;---------------------------------------------------------------------------
OVF_T2:	
		push R19          	;   R19
    	in R19,SREG      	;
   		push R19         	;   SREG
		;
		dec R14				;    , -
		brne T2_ex			;   /,  -
		
		sbrs cntrl,ENC		;  , -
		rjmp T2_off			;    ,
		
		clr R19						;
		sbr R19,(1<<SEK)	; . 
		cbr R19,(1<<ENC)	;    
		mov cntrl,R19		;
		
T2_off:	ldi R19,0			;  2
		out TCCR2,R19		;
		;
T2_ex:	pop R19          	;   SREG
    	out SREG,R19     	;
    	pop R19          	;   R19
		
		reti
		
;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
 Prnt_F:
		;    
		clr r18					;
		ldi r17,HIGH(870)		;  
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		LOAD_ADDR Y,decnum+3	;.  Y . .   
			;  
		;    LCD
		POZ_LCD 0,1				;0- , 1- 
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne Fr_100				;    
		ldi temp,0x0A			;  
		;  LCD 
		rcall D_big			;  LCD 
		rjmp Fr_10				;
		;  LCD  
Fr_100:	rcall D_big			;  LCD
		
Fr_10:	ld temp,-Y				; .  
		rcall D_big			;  LCD
		;  LCD  
		ld temp,-Y				; .  
		rcall D_big			;  LCD
		;  LCD 
		POZ_LCD 9,3				;9- , 3- 
		ldI temp,147			; 
		rcall lcd_put_char		;  LCD
		POZ_LCD 10,1			;10- , 1- 
		
		;  LCD   
		ld temp,-Y				; .  
		rcall D_big				;  LCD
		
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	push R30
		push R31
		;    LCD
		POZ_LCD 13,0					;13- , 0- 
		;   
		ldi temp,''					;   
		rcall lcd_put_char				;     
		
		cbi PORTC,2						; 
		pop R31
		pop R30
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	push R30
		push R31
		;    LCD
		POZ_LCD 13,0					;13- , 0- 
		;   
		ldi temp,'S'					;   S
		rcall lcd_put_char				;     
		
		sbi PORTC,2						; 
		pop R31
		pop R30
		ret

;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     ret

;=========================================================================
;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
 	.include "Nokia5110_driver_5.asm"	; LCD Nokia5110
 	.include "User_set.asm"				; 
;******************************************************************************
;===========================================================================
		;     
;---------------------------------------------------------------------------
  Messg1: .DB  130,131,131,' ',' ',' ',' ',' ',142,' ',' ',' ',' ',' ', 0,0	; 
  Messg2: .DB  ' ','','','','','','.',' ','','','','','',' ', 0,0
  Messg3: .DB  ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ', 0,0	; 
  Messg4: .DB  'M','H','z',0
  Messg5: .DB  ' ',' ','','','','','','','','','',' ',' ',' ', 0,0
  Messg6:  .DB  130,131,131, 0	; 0
  Messg7:  .DB  130,132,131, 0	; 1
  Messg8:  .DB  130,133,131, 0	; 2
  Messg9:  .DB  130,133,134, 0	; 3
  Messg10: .DB  130,133,135, 0	; 4
  Messg11: .DB  146,146,146,146,146,146,146,146,146,146,146,146,146,146, 0,0 ;

;=================================================================================

	.EXIT
	
	


